import yaml,copy,glob,os,pickle,itertools

#set to 1 if you have new game version/first start
reloadorig=0

if reloadorig==1:
    print ("load orig")
    with open('Xcom1Ruleset.rul', 'r') as fh:
        orig=yaml.safe_load(fh)
    lang={}
    print ("load lang")
    for lfile in glob.glob("../Language/*.yml"):
        with open(lfile, 'rb') as fh:
            print (lfile+":"+(lfile[12:-4]))
            tmp=yaml.safe_load(fh)
            if [x for x in tmp][0]==lfile[12:-4]:
                lang[lfile[12:-4]]=tmp
            else: print (lfile[12:-4]+" lang failed")
    print ("save orig")    
    with open('orig.pickle', 'wb') as fh:
        pickle.dump((orig,lang),fh)
else:
    with open('orig.pickle', 'rb') as fh:        
        (orig,lang)=pickle.load(fh)

alienraces=[x["id"] for x in orig["alienRaces"] if not "MIXED" in x["id"]]
alientypes=list(set([x['race'] for x in orig['units'] if 'rank' in x  and "ZOMBIE" not in x['race']]))
alienweapons=list(set(sum(sum([x["data"][0]["itemSets"] for x in orig["alienDeployments"]],[]),[])))
terrorists=[x["type"] for x in orig["units"] if x.get("rank","")=="STR_LIVE_TERRORIST"]
ufos=[x["type"] for x in orig["ufos"]]
missions=[x["type"] for x in orig["alienMissions"]]

mods={}

#mods["Cheat_initialFundingx100"]=dict(initialFunding=10*6000)
mods["Cheat_Fundingx10"]=dict(initialFunding=orig["initialFunding"]*10,countries=[dict(type=x["type"],fundingCap=x["fundingCap"]*10,fundingBase=x["fundingBase"]*10) for x in orig["countries"]])

stats=[x for x in orig["soldiers"][0]["minStats"]]
newstats=copy.deepcopy(orig["soldiers"][0])
for s in stats:
    for x in ["minStats","maxStats","statCaps"]:
        newstats[x][s]=200
mods["Cheat_Supersoldiers"]=dict(soldiers=[newstats])

facilities=[x["type"] for x in orig["facilities"] if x["buildTime"]>1]
changes=dict(facilities=[])
for f in facilities:
    changes["facilities"].append(dict(type=f,buildTime=2))
mods["Cheat_Bob_the_Builder"]=changes

research=[x["name"] for x in orig["research"] if x["cost"]>0]
changes=dict(research=[])
for r in research:
    changes["research"].append(dict(name=r,cost=2))
mods["Cheat_FastResearch"]=changes

changes=dict(facilities=[])
for f in orig["facilities"]:
    for test in ["labs","personnel","workshops","defense","storage","aliens","psiLabs","crafts"]:
        if test in f:
            changes["facilities"].append({"type":f["type"],test:f[test]*10})
mods["Cheat_SuperFacilities"]=changes

changes=dict(items=[])
for item in orig["items"]:
    if item["type"] in alienweapons or item["type"].split("_")[0] in [x.split("_")[1] for x in terrorists]:
        new={}
        if "power" in item:
            new["power"]=1            
        if "strengthApplied" in item:
            new["strengthApplied"]=False
        if len(new)>0:
            new["type"]=item["type"]
            changes["items"].append(new)
changes["units"]=[dict(specab=0,type="STR_CYBERDISC_TERRORIST")]
mods["Cheat_NoDamageAlien"]=changes

changes=dict(research=[])
tmprooms=["STR_EXAMINATION_ROOM","STR_ALIEN_SURGERY","STR_ALIEN_REPRODUCTION"]
rcount=0
tmpaliens=[]
for arace in [x for x in itertools.combinations(alienraces,2)]:
    for trace in [x for x in alientypes if x not in alienraces]:
        for room in tmprooms:
            changes["research"].append(dict(name="STR_MEDI_KIT_DEP_"+str(rcount),dependencies=(list(arace)+[trace]+[room]),cost=0,unlocks=["STR_MEDI_KIT"]))
            rcount+=1
changes["research"].append(dict(name="STR_MEDI_KIT",dependencies=["STR_MEDI_KIT_DEP_"+str(i) for i in range(rcount)]))
mods["Medikit_need_alien_and_room"]=changes


rname=[1,0.5,2]
for (rank,amount) in [("ENGINEER",len(ufos)),("NAVIGATOR",len(missions)),("MEDIC",len(alienraces)+len(terrorists))]:
    for r in rname:
        changes=dict(research=[])
        failednames=["STR_FAILED_"+rank+"_RESEARCH_"+str(i) for i in range(int(r*amount))]
        for n in failednames:
            changes["research"].append(dict(name=n,cost=0))
        for elem in orig["research"]:
            if elem["name"].endswith("_"+rank):
                print((rank,amount,r,int(r*amount),elem["name"]))
                changes["research"].append(dict(name=elem["name"],getOneFree=[x for x in failednames]))
        mods["Failed "+rank+" Research 1 to %s"%r]=changes


changes=dict(research=[])
needs=[["UFO_CONSTRUCTION",1,[]],["NEW_FIGHTER_CRAFT",2,[]],["NEW_FIGHTER_TRANSPORTER",4,[]],["ULTIMATE_CRAFT",6,[]]]
for n in range(len(needs)):
    for x in orig["research"]:
        if x["name"]=="STR_"+needs[n][0]:
            needs[n][2]=x["dependencies"]
for n in needs:
    rcount=0
    for ufo in [x for x in itertools.combinations(ufos,n[1])]:
        changes["research"].append(dict(name="STR_"+n[0]+"_UFO_DEP_"+str(rcount),dependencies=(list(ufo)+n[2]),cost=0,unlocks=["STR_"+n[0]]))
        rcount+=1
    changes["research"].append(dict(name="STR_"+n[0],dependencies=["STR_"+n[0]+"_UFO_DEP_"+str(i) for i in range(rcount)]))
mods["Craft Research Needs UFOs"]=changes


rname=["100%","50%","33%","25%"]
dlist=[
dict(src="STR_PLASMA_PISTOL_CLIP", space=2, consume=[3,3,9,6],produce=[2,1,2,1],  req="STR_PLASMA_PISTOL"),
dict(src="STR_PLASMA_RIFLE_CLIP",  space=3, consume=[1,2,3,4],produce=[1,1,1,1],  req="STR_PLASMA_RIFLE"),
dict(src="STR_HEAVY_PLASMA_CLIP",  space=4, consume=[1,1,3,2],produce=[2,1,2,1],  req="STR_HEAVY_PLASMA"),
dict(src="STR_BLASTER_BOMB",       space=6, consume=[1,2,1,4],produce=[3,3,1,3],  req="STR_BLASTER_LAUNCHER"),
dict(src="STR_STUN_BOMB",          space=4, consume=[1,2,3,4],produce=[1,1,1,1],  req="STR_SMALL_LAUNCHER"),
dict(src="STR_ALIEN_GRENADE",      space=5, consume=[1,1,3,2],produce=[2,1,2,1],  req=""),
dict(src="STR_UFO_POWER_SOURCE",   space=10,consume=[1,1,3,1],produce=[16,8,16,4],req="STR_UFO_CONSTRUCTION")
]
ri=0
for r in rname:
    m=dict(manufacture=[],extraStrings=[])
    li=0
    for l in dlist:
        m["manufacture"].append(dict(
            name="STR_BREAKDOWN_"+l["src"],
            category="STR_UFO_COMPONENT",
            listOrder=11851+li,
            cost=l["produce"][ri]*600,
            time=l["produce"][ri]*100+l["consume"][ri]*10*l["space"],
            space=l["space"],
            requiredItems={l["src"]:l["consume"][ri]},
            producedItems={"STR_ELERIUM_115":l["produce"][ri]},
            requires=[l["src"],"STR_ELERIUM_115","STR_ALIEN_ALLOYS"]+([l["req"]] if l["req"] else [])            
            ))
    for lng in lang:
        m['extraStrings'].append(dict(type=lng,strings={}))        
        for l in dlist:
            m['extraStrings'][-1]['strings']["STR_BREAKDOWN_"+l["src"]]=lang[lng][lng][l["src"]]+" -> "+lang[lng][lng]["STR_ELERIUM_115"]
    mods["Break2Elerium!"+r]=m

#plans:
#mods["more than 1 navigator for hyperwave"]=changes
#mods["Variable UFO Range"]=changes


for mod in mods:
    with open(mod+".rul", 'w') as fh:
        yaml.safe_dump(mods[mod],fh)
